<form [formGroup]="form" (ngSubmit)="save()">
  <allu-card>
    <mat-card-title>
      <div *ngIf="form.value.id">
        <span>{{['supervision.task.type', form.getRawValue().type] | translation}}</span>
        <span *ngIf="location"> - {{'location.locationKey' | translation:{key: location.locationKey} }}</span>
        <span> - {{['supervision.task.status', form.value.status] | translation}}</span>
        <span *ngIf="form.value.actualFinishingTime"> - {{form.value.actualFinishingTime | date:'short'}}</span>
      </div>
      <div *ngIf="!form.value.id">{{'supervision.task.newTask' | translation}}</div>
    </mat-card-title>
    <mat-card-content>
      <div fxLayout="row wrap" fxLayout.lt-md="column" fxLayoutGap="18px">
        <div fxFlex>
          <div fxLayout="row wrap" fxLayout.lt-md="column">
            <div fxFlex="100%" *ngIf="form.value.id">
              <div class="save-info">
                <div>{{'supervision.task.createdBy' | translation}}: {{form.value.creatorName}} {{form.value.creationTime | date:'short'}}
                </div>
              </div>
            </div>
            <div fxFlex="100%">
              <div fxLayout="row wrap" fxLayout.lt-md="column" fxLayoutGap="18px">
                <div fxFlex>
                  <mat-form-field class="input-full-width">
                    <mat-select [placeholder]="'supervision.task.type.title' | translation" class="input-full-width"
                                formControlName="type" required>
                      <mat-option *ngFor="let type of taskTypes" [value]="type">
                        {{['supervision.task.type', type] | translation}}
                      </mat-option>
                    </mat-select>
                  </mat-form-field>
                </div>
                <div fxFlex>
                  <mat-form-field class="input-full-width">
                    <mat-select [placeholder]="'supervision.task.owner' | translation" class="input-full-width"
                                formControlName="ownerId" required>
                      <mat-option *ngFor="let supervisor of availableSupervisors" [value]="supervisor.id">
                        {{supervisor.realName}}
                      </mat-option>
                    </mat-select>
                  </mat-form-field>
                </div>
                <div fxFlex>
                  <mat-form-field class="input-full-width">
                    <input matInput formControlName="plannedFinishingTime" required
                           [placeholder]="'supervision.task.plannedFinishingTime' | translation"
                           [matDatepicker]="plannedFinishingTimePicker">
                    <mat-datepicker-toggle matSuffix [for]="plannedFinishingTimePicker"
                                           [disabled]="form.disabled"></mat-datepicker-toggle>
                    <mat-datepicker #plannedFinishingTimePicker></mat-datepicker>
                    <mat-error *ngIf="form.get('plannedFinishingTime').hasError('inThePast')">
                      {{'supervision.task.field.plannedFinishingTimeInThePast' | translation}}
                    </mat-error>
                    <mat-error *ngIf="form.get('plannedFinishingTime').hasError('required')">
                      {{'supervision.task.field.plannedFinishingTimeMissing' | translation}}
                    </mat-error>
                  </mat-form-field>
                </div>
              </div>
            </div>
          </div>
          <div fxLayout="row">
            <div fxFlex="100%">
              <div fxLayout="row">
                <div fxFlex="100%">
                  <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="description"
                          [placeholder]="'supervision.task.description' | translation"></textarea>
                  </mat-form-field>
                </div>
              </div>
              <div fxLayout="row" *ngIf="form.getRawValue().result">
                <div fxFlex="100%">
                  <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="result"
                          [placeholder]="'supervision.task.result' | translation"></textarea>
                  </mat-form-field>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div fxFlex="0 1 auto">
          <supervision-task-location
            [taskId]="form.value.id"
            [locations]="locations"
            [applicationType]="application.type"
            [relatedLocation]="location"></supervision-task-location>
        </div>
      </div>


      <div fxLayout="row" fxLayout.sm="column">
        <div fxFlex="100%">
          <ng-container *ngIf="canApprove && !editing">
            <ng-container *availableTo="['ROLE_SUPERVISE']">
              <button mat-raised-button type="button" color="primary"
                      [disabled]="approveDisabled"
                      (click)="approve()">
                {{'supervision.task.approve' | translation}}
              </button>
              <button mat-raised-button type="button" color="primary" (click)="reject()">
                {{'supervision.task.reject' | translation}}
              </button>
            </ng-container>
          </ng-container>
          <ng-container *ngIf="canEdit">
            <ng-container *availableTo="['ROLE_CREATE_APPLICATION', 'ROLE_PROCESS_APPLICATION', 'ROLE_SUPERVISE', 'ROLE_ADMIN']">
              <ng-container *ngIf="editing">
                <button mat-raised-button type="submit" color="primary" [disabled]="!form.valid">
                  {{'common.button.save' | translation}}
                </button>
                <button mat-raised-button type="button" color="primary" (click)="cancel()">
                  {{'common.button.cancel' | translation}}
                </button>
              </ng-container>
              <ng-container *ngIf="!editing">
                <button mat-raised-button type="button" color="primary" (click)="edit()">
                  {{'common.button.edit' | translation}}
                </button>
                <button *ngIf="canRemove" mat-raised-button type="button" color="primary"
                        (click)="remove()">
                  {{'common.button.remove' | translation}}
                </button>
              </ng-container>
            </ng-container>
          </ng-container>
          <ng-container *ngIf="canTakeOwnership">
            <button mat-raised-button type="button" color="primary" (click)="moveToSelf(form.value.id)">
              {{'common.button.toSelf' | translation | uppercase}}
            </button>
          </ng-container>
        </div>
      </div>
    </mat-card-content>
  </allu-card>
</form>
